-- Pretpostavljamo da funkciju koristimo samo za n>=1
proizvodPrvih n
      | n == 1 = 1
      | otherwise = n * proizvodPrvih (n-1)

-- Ispitujemo da li je broj prost tako sto pozovemo pomocnu funkciju
-- koja ispituje da li postoji neki broj pocev od 2 do n koji deli broj n
prost n = prost1 n 2

-- Proveravamo da li postoji broj koji deli n (pocev od broja 2 - poziv iz prethodne funkcije)
-- ukoliko je k == n to znaci da smo proverili za svaki broj od 2 do n-1
-- i ustanovili da nijedan od njih ne deli n tako da vracamo True kao indikator da broj n jeste prost
-- ukoliko je n deljivo sa k, vracamo False (n nije prost)
-- ukoliko n nije deljivo sa k, pozovemo funkciju rekurzivno za sledeci broj (k+1)
prost1 n k
  | n == k = True
  | n `mod` k == 0 = False
  | otherwise = prost1 n (k+1)

nzd a b
  | b == 0 = a
  | otherwise = nzd b (a `mod` b)

tipJednacine a b c
  | a == 0 = "Degenerisana"
  | (b*b - 4*a*c) == 0 = "Jedno resenje"
  | (b*b - 4*a*c) > 0 = "Dva resenja"
  | otherwise = "Nema resenja"

uDekadnu x osn = if x==0 then 0 else uDekadnu (x `div` 10) osn * osn + (mod x 10)

izDekadne x osn = if x==0 then 0 else izDekadne (x `div` osn) osn * 10 + (mod x osn)

-- Trazimo ceo deo korena broja x
-- trazimo prvi broj (pocev od 1) ciji je kvadrat veci od kvadrata naseg broja x
-- i kao rezultat vracamo broj koji je za jedan manji
ceoDeo x = ceoDeo1 x 1

ceoDeo1 x i
  | (i*i) > x = (i-1)
  | otherwise = ceoDeo1 x (i+1)
